//  mi PlugIn sample
//  Copyright 1998 ABplus Inc. kazhida
//  All rights reserved.

unit piSample;

interface

uses
  PlugIns, Windows, Messages, SysUtils, Dialogs, Graphics;

type

//  TMiPlugInspāA
//  vOC̋@\NX`܂B
//  ʂɁAKÂ悤ɂKv͂ȂA
//  PɁAKvȎ葱/֐΂Ȃ̂łA
//  DLLŁAIuWFNg̈nł悤ɂȂA
//  gƂA\z邽߁A
//  NXƂĎĂقKɂȂ邩܂B

  TMpiSample = class(TMiPlugIns)
  private
    startTime: TDateTime;
    lastTime: TDateTime;
    freeTime: TDateTime;
    isFreeTime: boolean;
    strHolder: string;
    function SearchWindow(s: PChar): boolean;
  public
    isRunaway: boolean;
    constructor Create;
    procedure Enable; override;
    procedure Disable; override;
    procedure Notify(Handle: HWnd; n: TDateTime); override;
    procedure NotifyFreq(Handle: HWnd; n: TDateTime); override;
    function  Discription: PChar; override;
    procedure SetProps; override;
    function GetStartTime: string;
    function GetRunningTime: string;
    function GetFreeTime: string;
  end;

var
//  IuWFNgÓIɊmۂĂ܂B
  MpiInstance: TMpiSample;

//  Export葱/֐̐錾
procedure MpiEnable; export; stdcall;
procedure MpiDisable; export; stdcall;
procedure MpiNotify(Handle: HWnd; n: TDateTime); export; stdcall;
procedure MpiNotifyFreq(Handle: HWnd; n: TDateTime); export; stdcall;
function  MpiDiscription: PChar; export; stdcall;
procedure MpiSetProps; export; stdcall;

implementation

uses
  Forms, pfSample;

constructor TMpiSample.Create;
//  ɁAPrivatetB[hĂ܂B
begin
  isFreeTime := false;
  strHolder := '';
  //  ćAEnable\bhŃZbg
  Enable;
end;

procedure TMpiSample.Enable;
//  EnableɁAZbg܂B
begin
  startTime := Now;
  lastTime := startTime;
  freeTime := 0;
end;

procedure TMpiSample.Disable;
//  ȈłB
//  RgAEgĂ̂߂ƁA
//  L^Ot@CɎc悤ɂȂ܂B
{----- comment out ---------- comment out ---------
const
  logFile = 'c:\Work\JobWatch.log';
var
  f: TextFile;
 ----- comment out ---------- comment out ---------}
begin
{----- comment out ---------- comment out ---------

  ////΂ɃOcp^[
  ////AssignFile(f, logFile);
  ////if FileExists(logFile)
  ////then Append(f)
  ////else Rewrite(f);

  ////ƂƃOt@CƂ̂ݎcp^[
  if Not FileExists(logFile) then exit;
  AssignFile(f, logFile);
  Append(f);

  //  N
  Write(f, FormatDateTime('yyyy/mm/dd hh:nn:ss', startTime), chr(9));
  //  I
  Write(f, FormatDateTime('yyyy/mm/dd hh:nn:ss', Now), chr(9));
  //  Vł(P)
  WriteLn(f, IntToStr(Trunc(freeTime * 24 * 60)));
  Flush(f);
  CloseFile(f);
 ----- comment out ---------- comment out ---------}
end;

function  TMpiSample.Discription: PChar;
//  Ԃ܂B
const
  msg1 = 'vOC̃TvłB';
  msg2 = 'gݒNbNƁANƌoߎԂȂǂ\܂B';
  copy1 = 'Copyright 1998 ABplus Inc. kazhida';
  copy2 = 'All rights reserved.';
begin
  Discription :=  msg1 + chr(13) + chr(10)
               +  msg2 + chr(13) + chr(10)
               + copy1 + chr(13) + chr(10)
               + copy2;
end;

procedure TMpiSample.Notify(Handle: HWnd; n: TDateTime);
//  ̃vOĆAoߎԂƂv̂ŁA
//  NotifyꂽL^Ă܂B
var
  exist: boolean;
begin
  //  t[Z邩ǂTāA
  //  ΁At[ZғԂɉ
  exist := SearchWindow('ذ ް');  //'ذ'̂Ƃ͹ްтJnĂȂ̂ŃJEgȂ
  //exist := exist or SearchWindow('Netscape'); //lXPJEgႤƂ
  if isFreeTime and exist
  then freeTime := freeTime + (n - lastTime);
  isFreeTime := exist;
  //  lastTimeXV
  lastTime := n;
end;

procedure TMpiSample.NotifyFreq(Handle: HWnd; n: TDateTime);
//  ƈ̂܂
var
  fc: TColor;
  bc: TColor;
  px: integer;
begin
  if isRunaway then
  begin
    //  FƂʒu𒲂ׂ
    fc := GetForeColor(Handle);
    bc := GetBackColor(Handle);
    px := GetPosition(Handle);
    //  F͔]
    fc := $FFFFFF xor fc;
    bc := $FFFFFF xor bc;
    //  ʒu͉Eɂ炷
    if px > 0 then px := px - 1;
    SetColors(Handle, fc, bc);
    SetPosition(Handle, px);
  end;
end;

procedure TMpiSample.SetProps;
//  ݒEBhE\܂B
begin
  FormSample := TFormSample.Create(Application);
  with FormSample do
  begin
    try
      //  gݒEBhEɓn܂B
      PostInfo(Self);
      //  \܂BModalłȂꍇ́A
      //  mi.exeɏIĂ܂Ƃ肦̂ŁA댯łB
      ShowModal;
    finally
      Free;
    end;
  end;
  FormSample := nil;
  //  ݒWindoẃAEnableŐāADisableŊJ
  //  Ă̂łAłAłSetPropsĂ΂邽т
  //  /J悤ɂĂ݂܂B
end;

function TMpiSample.GetStartTime: string;
begin
  GetStartTime := FormatDateTime('hh:nn:ss', startTime);
end;

function TMpiSample.GetRunningTime: string;
begin
  GetRunningTime := FormatDateTime('hh:nn:ss', lastTime - startTime);
end;

function TMpiSample.GetFreeTime: string;
begin
  GetFreeTime := FormatDateTime('hh:nn:ss', freeTime);
end;

{
  ́AvOĈ̂ɂ́A܂֌W܂B
  t[Z̃EBhE邩ǂTA
  Win32APĨׂׂ[`łB
}

var
  ewpExist: boolean;

function EnumWindowsProc(Handle: HWnd; lp: LPARAM): Bool; stdcall;
var
  cap: PChar;
  trg: PChar;
  siz: integer;
begin
  EnumWindowsProc := true;
  trg := PChar(lp);
  siz := GetWindowTextLength(Handle);
  GetMem(cap, siz + 1);
  GetWindowText(Handle, cap, siz);
  if StrPos(cap, trg) <> nil then
  begin
    ewpExist := true;
    EnumWindowsProc := false;
  end;
  FreeMem(cap);
end;

function TMpiSample.SearchWindow(s: PChar): boolean;
begin
  ewpExist := false;
  EnumWindows(TFNWndEnumProc(@EnumWindowsProc), LPARAM(s));
  SearchWindow := ewpExist;
end;


{
  ܂łAvOCENX̎ŁA
  炪AExport葱/֐̎łB
  ƂĂAΉ郁\bhĂł邾łB
}

procedure MpiEnable;
begin
  MpiInstance.Enable;
end;

procedure MpiDisable;
begin
  MpiInstance.Disable;
end;

procedure MpiNotify(Handle: HWnd; n: TDateTime);
begin
  MpiInstance.Notify(Handle, n);
end;

procedure MpiNotifyFreq(Handle: HWnd; n: TDateTime);
begin
  MpiInstance.NotifyFreq(Handle, n);
end;

function  MpiDiscription: PChar;
begin
  MpiDiscription := MpiInstance.Discription;
end;

procedure MpiSetProps;
begin
  MpiInstance.SetProps;
end;

begin
  //  ŌɁAÓIɊmۂIuWFNgϐɎ̂𐶐Ă܂B
  //  unit̏[`Ă̂APascaln̂ƂłˁB
  MpiInstance := TMpiSample.Create;
end.

